<?php 
//获得一个附加表单
//-----------------------------
function GetFormItem($ctag,$admintype='admin')
{
	$fieldname = $ctag->GetName();
	$formitem = GetSysTemplets("custom_fields_{$admintype}.htm");
	$fieldType = 	$ctag->GetAtt("type");
	$innertext = trim($ctag->GetInnerText());
	if($innertext!=""){
		 if($ctag->GetAtt("type")=='select'){
		 	  $myformItem = '';
		 	  $items = explode(',',$innertext);
		 	  $myformItem = "<select name='$fieldname' style='width:150px'>";
		 	  foreach($items as $v){
		 	 	  $v = trim($v);
		 	 	  if($v!=''){ $myformItem.= "<option value='$v'>$v</option>\r\n"; }
		 	  }
		 	  $myformItem .= "</select>\r\n";
		 	  $formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace("~form~",$myformItem,$formitem);
		    return $formitem;
		 }else if($ctag->GetAtt("type")=='radio'){
		 	  $myformItem = '';
		 	  $items = explode(',',$innertext);
		 	  foreach($items as $v){
		 	 	  $v = trim($v);
		 	 	  $i = 0;
		 	 	  if($v!=''){
		 	 	  	if($i==0) $myformItem .= "<input type='radio' name='$fieldname' class='np' value='$v' checked>$v\r\n";
		 	 	  	else $myformItem .= "<input type='radio' name='$fieldname' class='np' value='$v'>$v\r\n";
		 	 	  }
		 	  }
		 	  $formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace("~form~",$myformItem,$formitem);
		    return $formitem;
		 }else{
		    $formitem = str_replace('~name~',$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace('~form~',$innertext,$formitem);
		    $formitem = str_replace('@value','',$formitem);
		    return $formitem;
		 }
	}
	
	if($fieldType=="htmltext"||$fieldType=="textdata")
	{
		$formitem = "";
		$formitem .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"margin-bottom:3px\">";
		$formitem .= "<tr><td width=\"80\" class=\"bline\" height='360'>&nbsp;".$ctag->GetAtt('itemname')."</td><td class=\"bline\">";
		
		if($admintype=='admin') $formitem .= GetEditor($fieldname,'',350,'Basic','string');
		else $formitem .= GetEditor($fieldname,'',350,'Member','string');
		
		$formitem .= "</td></tr></table>\r\n";
		return $formitem;
	}
	else if($fieldType=="multitext")
	{
		$innertext = "<textarea name='$fieldname' id='$fieldname' style='width:100%;height:80'></textarea>\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($fieldType=="datetime")
	{
		$nowtime = GetDateTimeMk(mytime());
		$innertext = "<input name=\"$fieldname\" value=\"$nowtime\" type=\"text\" id=\"$fieldname\" style=\"width:200px\">";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($fieldType=="img"||$fieldType=="imgfile")
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectImage('form1.$fieldname','big')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($fieldType=="media")
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectMedia('form1.$fieldname')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($fieldType=="addon")
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectSoft('form1.$fieldname')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($fieldType=="media")
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectMedia('form1.$fieldname')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else
	{
		if($ctag->GetAtt('default')!="") $dfvalue = $ctag->GetAtt('default');
		else $dfvalue = "";
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:200px' value='$dfvalue'>\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
}
//---------------------------
//处理不同类型的数据
//---------------------------
function GetFieldValue($dvalue,$dtype,$aid=0,$job='add',$addvar='',$admintype='admin')
{
	global $cfg_basedir,$cfg_cmspath,$adminID,$cfg_ml;
	
	if(!empty($adminID)) $adminid = $adminID;
	else $adminid = $cfg_ml->M_ID;
	
	if($dtype=="int"){
		return GetAlabNum($dvalue);
	}
	else if($dtype=="float"){
	  return GetAlabNum($dvalue);
	}
	else if($dtype=="datetime"){
		return GetMkTime($dvalue);
	}
	else if($dtype=="textdata"){
		if($job=='edit'){
			$addvarDirs = explode('/',$addvar);
			$addvarDir = ereg_replace("/".$addvarDirs[count($addvarDirs)-1]."$","",$addvar);
			$mdir = $cfg_basedir.$addvarDir;
			if(!is_dir($mdir)){
				MkdirAll($mdir);
			}
			$fp = fopen($cfg_basedir.$addvar,"w");
		  fwrite($fp,stripslashes($dvalue));
		  fclose($fp);
		  CloseFtp();
	    return $addvar;
	  }else{	
		  $ipath = $cfg_cmspath."/include/textdata";
		  $tpath = ceil($aid/5000);
		  if(!is_dir($cfg_basedir.$ipath)) MkdirAll($cfg_basedir.$ipath,777);
		  if(!is_dir($cfg_basedir.$ipath.'/'.$tpath)) MkdirAll($cfg_basedir.$ipath.'/'.$tpath,777);
		  $ipath = $ipath.'/'.$tpath;
		  $filename = "{$ipath}/{$aid}.txt";
		  $fp = fopen($cfg_basedir.$filename,"w");
		  fwrite($fp,stripslashes($dvalue));
		  fclose($fp);
		  CloseFtp();
	    return $filename;
	  }
	}
	else if($dtype=="img"||$dtype=="imgfile"){
		$iurl = stripslashes($dvalue);
    if(trim($iurl)=="") return "";
    $iurl = trim(str_replace($GLOBALS['cfg_basehost'],"",$iurl));
    $imgurl = "{dede:img text='' width='' height=''} ".$iurl." {/dede:img}";
    if(eregi("^http://",$iurl) && $GLOBALS['isUrlOpen']) //远程图片
    {
       $reimgs = "";
       if($isUrlOpen){
	       $reimgs = GetRemoteImage($iurl,$adminid);
	       if(is_array($reimgs)){
		        if($dtype=="imgfile") $imgurl = $reimgs[1];
	          else $imgurl = "{dede:img text='' width='".$reimgs[1]."' height='".$reimgs[2]."'} ".$reimgs[0]." {/dede:img}";
	       }
	     }else{
	     	 if($dtype=="imgfile") $imgurl = $iurl;
	     	 else $imgurl = "{dede:img text='' width='' height=''} ".$iurl." {/dede:img}";
	     }
    }
    else if($iurl!=""){  //站内图片
	     $imgfile = $cfg_basedir.$iurl;
	     if(is_file($imgfile)){
		     $imginfos = GetImageSize($imgfile,&$info);
		     if($dtype=="imgfile") $imgurl = $iurl;
		     else $imgurl = "{dede:img text='' width='".$imginfos[0]."' height='".$imginfos[1]."'} $iurl {/dede:img}";
	     }
    }
    return addslashes($imgurl);
	}else{
		return $dvalue;
	}
}
//获得带值的表单(编辑时用)
//-----------------------------
function GetFormItemValue($ctag,$fvalue,$admintype='admin')
{
	$fieldname = $ctag->GetName();
	$formitem = $formitem = GetSysTemplets("custom_fields_{$admintype}.htm");
  
  $innertext = trim($ctag->GetInnerText());
	if($innertext!=""){
		 if($ctag->GetAtt("type")=='select'){
		 	  $myformItem = '';
		 	  $items = explode(',',$innertext);
		 	  $myformItem = "<select name='$fieldname' style='width:150px'>";
		 	  foreach($items as $v){
		 	 	  $v = trim($v);
		 	 	  if($v!=''){
		 	 	  	if($fvalue==$v) $myformItem.= "<option value='$v' selected>$v</option>\r\n";
		 	 	  	else $myformItem.= "<option value='$v'>$v</option>\r\n";
		 	 	  }
		 	  }
		 	  $myformItem .= "</select>\r\n";
		 	  $formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace("~form~",$myformItem,$formitem);
		    return $formitem;
		 }else if($ctag->GetAtt("type")=='radio'){
		 	  $myformItem = '';
		 	  $items = explode(',',$innertext);
		 	  foreach($items as $v){
		 	 	  $v = trim($v);
		 	 	  if($v!=''){
		 	 	  	if($fvalue==$v) $myformItem.= "<input type='radio' name='$fieldname' class='np' value='$v' checked>$v\r\n";
		 	 	    else $myformItem.= "<input type='radio' name='$fieldname' class='np' value='$v'>$v\r\n";
		 	 	  }
		 	  }
		 	  $formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace("~form~",$myformItem,$formitem);
		    return $formitem;
		 }else{
		    $formitem = str_replace('~name~',$ctag->GetAtt('itemname'),$formitem);
		    $formitem = str_replace('~form~',$innertext,$formitem);
		    $formitem = str_replace('@value',$fvalue,$formitem);
		    return $formitem;
		 }
	}
  
  //文本数据的特殊处理
  if($ctag->GetAtt("type")=="textdata")
  {
  	if(is_file($cfg_basedir.$fvalue)){
  	  $fp = fopen($cfg_basedir.$fvalue,'r');
		  $okfvalue = "";
		  while(!feof($fp)){ $okfvalue .= fgets($fp,1024); }
		  fclose($fp);
	  }else{ $okfvalue=""; }
		
		if($admintype=='admin')  $myformItem = GetEditor($fieldname,$okfvalue,350,'Basic','string')."\r\n <input type='hidden' name='{$fieldname}_file' value='{$fvalue}'>\r\n ";
		else $myformItem = GetEditor($fieldname,$okfvalue,350,'Member','string')."\r\n <input type='hidden' name='{$fieldname}_file' value='{$fvalue}'>\r\n ";
		
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$myformItem,$formitem);
		
		return $formitem;
  }  
	else if($ctag->GetAtt("type")=="htmltext")
	{
		if($admintype=='admin')  $myformItem = GetEditor($fieldname,$okfvalue,350,'Basic','string')."\r\n ";
		else $myformItem = GetEditor($fieldname,$okfvalue,350,'Member','string')."\r\n ";
		
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$myformItem,$formitem);
		
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="multitext")
	{
		$innertext = "<textarea name='$fieldname' id='$fieldname' style='width:100%;height:80px'>$fvalue</textarea>\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="datetime")
	{
		$nowtime = GetDateTimeMk($fvalue);
		$innertext = "<input name=\"$fieldname\" value=\"$nowtime\" type=\"text\" id=\"$fieldname\" style=\"width:200px\">";
		//$innertext .= "<input name=\"selPubtime\" type=\"button\" id=\"selkeyword\" value=\"选择\" onClick=\"showCalendar('$fieldname', '%Y-%m-%d %H:%M:00', '24');\">";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="img")
	{
		$ndtp = new DedeTagParse();
    $ndtp->LoadSource($fvalue);
    if(!is_array($ndtp->CTags)){
    	$ndtp->Clear();
    	$fvalue =  "";
    }
    $ntag = $ndtp->GetTag("img");
    $fvalue = trim($ntag->GetInnerText());
		$innertext = "<input type='text' name='$fieldname' value='$fvalue' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectImage('form1.$fieldname','big')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="imgfile")
	{
		$innertext = "<input type='text' name='$fieldname' value='$fvalue' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectImage('form1.$fieldname','big')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="media")
	{
		$innertext = "<input type='text' name='$fieldname' value='$fvalue' id='$fieldname' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectMedia('form1.$fieldname')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else if($ctag->GetAtt("type")=="addon")
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' value='$fvalue' style='width:300px'><input name='".$fieldname."_bt' type='button' value='浏览...' onClick=\"SelectSoft('form1.$fieldname')\">\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
	else
	{
		$innertext = "<input type='text' name='$fieldname' id='$fieldname' style='width:200px' value='$fvalue'>\r\n";
		$formitem = str_replace("~name~",$ctag->GetAtt('itemname'),$formitem);
		$formitem = str_replace("~form~",$innertext,$formitem);
		return $formitem;
	}
}
?>